/*The field recordings are hardcoded such that buffers a and b are the drone and c and d are the birds.
This should eventually change to pointing to folders but that would require a rework of the GUI.
Also, I have been performing the fade manually hence the code for the automated fade being commented out.
*/
(
a = Buffer.read(s, "/home/mwinter/Portfolio/fade_and_aviary/harmonium_fifth_final_norm_mono.wav");
b = Buffer.read(s, "/home/mwinter/Portfolio/fade_and_aviary/gong_final_norm_mono.wav");
c = Buffer.read(s, "/home/mwinter/Portfolio/fade_and_aviary/birds_wulf_norm_mono.wav");
d = Buffer.read(s, "/home/mwinter/Portfolio/fade_and_aviary/birds_norm_mono.wav");
)
(
w = 100;
l = 30;
m = 5;
f = Array.fill(l, { arg i; (i + 1) * w });
q = w/f;
SynthDef("switch", {
	arg out=0, soundBufnum1=0, soundBufnum2 = 1, soundBufnum3 = 2, soundBufnum4 = 3, att = 0.1, rel = 0.01, dust = 0.5, prob = 0.7,
	ctlin = #[0,0,0,0,0,0,0,0,0,0];
	var fadeOut, fadeIn,
	soundInA, soundInB,
	inA, inB, inC, inD,
	filtA, filtB,
	trig, res,
	gTrigA, gTrigB,
	grainA, grainB,
	imp, delimp;

	fadeOut = Line.ar(1, 0, m * 60);
	fadeIn = Line.ar(0, 0.75, 10);
	Poll.ar(Impulse.ar(1), fadeOut, \fade);
	Poll.ar(Impulse.ar(1), BufFrames.ir(soundBufnum3) - (BufSampleRate.ir(soundBufnum3) * 60 * m), \start);

	//inA = PlayBuf.ar(1, soundBufnum1, BufRateScale.kr(soundBufnum1), loop: 1) * fadeOut;
	gTrigA = Dust.kr(2);
	grainA = GrainBuf.ar(1, gTrigA, TRand.kr(4, 8, gTrigA), soundBufnum1) /** fadeOut*/;
	soundInA = SoundIn.ar(0);

	//inB =  PlayBuf.ar(1, soundBufnum2, BufRateScale.kr(soundBufnum2), loop: 1) * fadeOut;
	gTrigB = Dust.kr(2);
	grainB = GrainBuf.ar(1, gTrigB, TRand.kr(4, 8, gTrigB), soundBufnum2) /** fadeOut*/;
	soundInB = SoundIn.ar(1);

	inA = (grainA * ctlin[0]) + (soundInA * ctlin[2]);
	inB = (grainB * ctlin[1]) + (soundInB * ctlin[3]);
	inC =  PlayBuf.ar(1, soundBufnum3, BufRateScale.kr(soundBufnum3),
		startPos: BufFrames.kr(soundBufnum3) - (BufSampleRate.kr(soundBufnum3) * 60 * (m + 1.5)), loop: 1) * ctlin[4] * fadeIn * 10;
	inD =  PlayBuf.ar(1, soundBufnum4, BufRateScale.kr(soundBufnum3)) * ctlin[4] * fadeIn * 8;

	filtA = BPF.ar(inA, f, q);
	filtB = BPF.ar(inB, f, q);

	trig = { Dust.ar(dust) } ! l;
	res = {|i| Lag.ar(LeakDC.ar(Select.ar(TRand.ar(0, 1, trig[i]) > prob, [Normalizer.ar(filtA[i], Amplitude.ar(inA), 0.1), filtB[i]]), 1), 0.001)} ! l;
	res = Mix.new(res);
	res =  Lag.ar(LeakDC.ar(Select.ar((Amplitude.ar(inC, att, rel) < Amplitude.ar(res, att, rel)), [(inC + inD) * 2, Normalizer.ar(res, 0.5, 0.1)])), 0.001);

	Out.ar([0, 1],
		(
			(grainA * ctlin[5]) +
			(grainB * ctlin[6]) +

			(soundInA * ctlin[7]) +
			(soundInB * ctlin[8]) +

			(res * ctlin[9])
		) * fadeIn
	);


	imp = Impulse.kr(10);
    delimp = Delay1.kr(imp);

	SendReply.kr(imp,
        '/levels',
        values: [
			//ins

			[Amplitude.kr(grainA * ctlin[0]), K2A.ar(Peak.ar(grainA * ctlin[0], delimp).lag(0, 3))],
			[Amplitude.kr(grainB * ctlin[1]), K2A.ar(Peak.ar(grainB * ctlin[1], delimp).lag(0, 3))],

			[Amplitude.kr(soundInA * ctlin[2]), K2A.ar(Peak.ar(soundInA * ctlin[2], delimp).lag(0, 3))],
			[Amplitude.kr(soundInB * ctlin[3]), K2A.ar(Peak.ar(soundInB * ctlin[3], delimp).lag(0, 3))],

			[Amplitude.kr(inC), K2A.ar(Peak.ar(inC, delimp).lag(0, 3))],

			//outs
			[Amplitude.kr(grainA * ctlin[5]), K2A.ar(Peak.ar(grainA * ctlin[5], delimp).lag(0, 3))],
			[Amplitude.kr(grainB * ctlin[6]), K2A.ar(Peak.ar(grainB * ctlin[6], delimp).lag(0, 3))],

			[Amplitude.kr(soundInA * ctlin[7]), K2A.ar(Peak.ar(soundInA * ctlin[7], delimp).lag(0, 3))],
			[Amplitude.kr(soundInB * ctlin[8]), K2A.ar(Peak.ar(soundInB * ctlin[8], delimp).lag(0, 3))],

			[Amplitude.kr(res * ctlin[9]), K2A.ar(Peak.ar(res * ctlin[9], delimp).lag(0, 3))]
		],
        replyID: [1900, 1901, 1902, 1903, 1904, 1905, 1906, 1907, 1908, 1909]
    );

    }).add;
)
(
var synth, win,
levels, levelIndicators,
grainAInLevels, grainBInLevels, soundInALevels, soundInBLevels,
grainAOutLevels, grainBOutLevels, soundOutALevels, soundOutBLevels, resOutLevels;
synth = Synth("switch", [\soundBufnum1, a.bufnum, \soundBufnum2, b.bufnum, \soundBufnum3, c.bufnum, \soundBufnum4, d.bufnum]);

win = Window.new("fade and aviary", Rect(128, 64, 350, 600));
win.view.decorator = FlowLayout(win.view.bounds);
win.view.decorator.gap=2@2;

levels = [0,0,0,0,0,0,0,0,0,0];
levelIndicators = {|i|
	var lI;
	EZSlider(win, 40 @ 250, "", ControlSpec(0, 1, \lin, 0, 0),
		{|v| levels[i] = v.value; synth.set("ctlin", levels )}, layout: 'vert');
	lI = LevelIndicator(win, Rect(10, 10, 20, 250));
	lI} ! 10;

EZSlider(win, 350 @ 40, "dust freq ", ControlSpec(0.5, 3, \lin, 0, 0.5), {|v| synth.set("dust", v.value )});
EZSlider(win, 350 @ 40, "spec prob ", ControlSpec(0.1, 0.7, \lin, 0, 0.7), {|v| synth.set("prob", v.value )});

o = OSCFunc({arg msg;
    {
		levelIndicators[msg[2]-1900].value = msg[3].ampdb.linlin(-40, 0, 0, 1);
		levelIndicators[msg[2]-1900].peakLevel = msg[4].ampdb.linlin(-40, 0, 0, 1);
    }.defer;
}, '/levels', s.addr);


win.front;
)